
import g4p_controls.*;

import processing.serial.*;
Serial bluetooth;


int target1 = 2047;          // "A" value from SIMTools
int target2 = 2047;          // "B" value from SIMTools
int feedback1 = 2047;        // "C" value from Encoder
int feedback2 = 2047;        // "D" value from Encoder
int pwm1;                    // "E" value from PID output
int pwm2;                    // "F" value from PID output
int current1;                // "G" value from Sabertooth
int current2;                // "H" value from Sabertooth
int temp1;                   // "I" value from Sabertooth
int temp2;                   // "J" value from Sabertooth

int offsetM1_val;             // "M" value from EEprom
int offsetM2_val;             // "N" value from EEprom
int pwm_max_val;             // "P" value from EEprom
int kp_val;                  // "R" value from EEprom
int ki_val;                  // "S" value from EEprom
int kd_val;                  // "T" value from EEprom
int speed_ramp_val;          // "V" value from EEprom

int target_Both;             // "X" value from Curves

// "c.."  connect to Arduino
// "d.."  disconnect from Arduino
// "m.."  mode 'manual'
// "s.."  mode 'simtools'
// "r.X"  request value "X" from Arduino
// "w.."  write values to EEprom
// "z.."  start zero adjust sequence

boolean switch_once = false;
boolean connectArd = false;         // connected to Arduino

//*****************************************

void setup() 
{
  size(1060, 860);
  smooth(1);
  
  createGUI();
  
  printArray(Serial.list());
  bluetooth = new Serial(this, "COM22", 115200);

  println("bluetooth serial ok");

  background(100, 140, 200);
  stroke(255);
  fill(25);
  rect(oscX1 - 1, oscY, oscWidth + 1, oscHeight + 1);      // osc windows
  rect(oscX2 - 1, oscY, oscWidth + 1, oscHeight + 1);

  disable_manual();               // disable manual handles
  disable_curve();                // disable curve handles
  enable_simtools();              // enable simtool handles
  option_manual.setVisible(false);
  option_curve.setVisible(false);
  
  sendCommand('s', 0);                   // mode 'simtools' to arduino
}

//************************************************

void draw() 
{
  noStroke();
  fill(100, 140, 200);
  rect(0, 400, 1060, 460);
 
  if(! switch_once) {           // run only one time

    switch_once = true;
  }
  
  pollSerial(); 

  if(connectArd)
  {
    oscilloscopes();
    slider_release();
  }

  waves();

} //<>//