
int oscX1 = 540;             // Oscilloscope  variables
int oscX2 = 20;
int oscY = 20;
int oscWidth = 500;
int oscHeight = 350;
int oscXval = 0;

int targetM1_old = 175;    // old values for line-drawing
int targetM2_old = 175;
int feedbackM1_old = 175;
int feedbackM2_old = 175;
int pwmM1_old = 175;
int pwmM2_old = 175;
int currentCH1_old = 175;
int currentCH2_old = 175;
int tempCH1_old;
int tempCH2_old;

//*****************************************************************

void oscilloscopes() {

  int targetM1 = y_val(target1);       // blue line        // get new values for line-drawing
  int targetM2 = y_val(target2);
  int feedbackM1 = y_val(feedback1);   // green line
  int feedbackM2 = y_val(feedback2);
  int pwmM1 = y_val(pwm1);             // yellow line
  int pwmM2 = y_val(pwm2);
  int currentCH1 = y_val(current1);    // ?? line
  int currentCH2 = y_val(current2);
  int tempCH1 = y_val(temp1);          // ?? line
  int tempCH2 = y_val(temp2);
//---------------
  stroke(25);                               // erase old lines
  line(oscX1, oscY + 1, oscX1, oscY + oscHeight);
  line(oscX2, oscY + 1, oscX2, oscY + oscHeight);
//---------------
  if (checkbox_target.isSelected()) {       // lines motor target
    stroke(100, 100, 255);
    oscLine1(targetM1_old, targetM1);
    oscLine2(targetM2_old, targetM2);
}
  if (checkbox_feedback.isSelected()) {      // lines movement feedback
    stroke(50, 225, 50);
    oscLine1(feedbackM1_old, feedbackM1);
    oscLine2(feedbackM2_old, feedbackM2);
  }
  if (checkbox_pwm.isSelected()) {           // lines pwm from pid
    stroke(200, 200, 0);
    oscLine1(pwmM1_old, pwmM1);
    oscLine2(pwmM2_old, pwmM2);
  }
  if (checkbox_current.isSelected()) {       // lines motor current
    stroke(0, 200, 200);
    oscLine1(currentCH1_old, currentCH1);
    oscLine2(currentCH2_old, currentCH2);
  }
  if (checkbox_temperature.isSelected()) {   // lines motor temp
    stroke(150, 225, 50);
    oscLine1(tempCH1_old, tempCH1);
    oscLine2(tempCH2_old, tempCH2);
  }
//---------------
  if (checkbox_pwm.isSelected()) {       // dots pwm max
    stroke(150);
    oscPoint1(y_dotval(pwm_max_val));
    oscPoint2(y_dotval(pwm_max_val));
    oscPoint1(-y_dotval(pwm_max_val));
    oscPoint2(-y_dotval(pwm_max_val));
  }
  stroke(50, 200, 200);                 // dots zero value
  oscPoint1(0);
  oscPoint2(0);
//---------------
  loadPixels();                              // move osc's to the right
  for (int r = 0 + oscY; r < oscHeight + oscY; r++) {
    arrayCopy(pixels, width * r + oscX1, pixels, width * r + oscX1 + 1, oscWidth - 1);
  }
  for (int r = 0 + oscY; r < oscHeight + oscY; r++) {
    arrayCopy(pixels, width * r + oscX2, pixels, width * r + oscX2 + 1, oscWidth - 1);
  }
  updatePixels();
//---------------  
  targetM1_old = targetM1;             // make space for new values
  targetM2_old = targetM2;
  feedbackM1_old = feedbackM1;
  feedbackM2_old = feedbackM2;
  pwmM1_old = pwmM1;
  pwmM2_old = pwmM2;
  currentCH1_old = currentCH1;
  currentCH2_old = currentCH2;
  tempCH1_old = tempCH1;
  tempCH2_old = tempCH2;
}

//***************************************************************

void oscLine1(int y_old, int y_new) {    // line on osc 1
  line(oscX1 + 1, oscY + oscHeight - y_old, oscX1, oscY + oscHeight - y_new);
}

//***************************************************************

void oscLine2(int y_old, int y_new) {    // line on osc 2
  line(oscX2 + 1, oscY + oscHeight - y_old, oscX2, oscY + oscHeight - y_new);
}

//***************************************************************

void oscPoint1(int y) {                  // dotted line on osc 1
  if ((frameCount & 0x04) > 0) {
    point(oscX1, oscY + oscHeight / 2 - y);
  }
}

//***************************************************************

void oscPoint2(int y) {                  // dotted line on osc 2
  if ((frameCount & 0x04) > 0) {
    point(oscX2, oscY + oscHeight / 2 - y);
  }
}

//***************************************************************

int y_val(int value) {                    // scale down line values
  return int(value / 4095.0 * (oscHeight - 1));
}

//***************************************************************

int y_dotval(int value) {                    // scale down dot values
  return round(value / 8191.0 * (oscHeight - 1)) ;
}