
int rxByte = 0 ;                    // Serial variables
int bufferEnd = -1;
int[] rxBuffer = { 0, 0, 0, 0, 0 };
int command_val;

byte[] txBuffer = { 0, 0, 0, 0, 0 };

//********************************************************

void parseCommand()
{
  
//  println("Command received:  " + char(rxBuffer[0]) + "  " + hex(command_val));
  
  switch (rxBuffer[0])
  {
    case 'A':
      if((option_simtools.isSelected()) && (imgTogButton_sim.getState() > 0)) { target1 = command_val; }
      break;
    case 'B':
      if((option_simtools.isSelected()) && (imgTogButton_sim.getState() > 0)) { target2 = command_val; }
      break;
    case 'C':
      feedback1 = command_val;
      label_feedback1.setText(str(command_val - 2047));
      label_feedback1.setTextBold();
      break;
    case 'D':
      feedback2 = command_val;
      label_feedback2.setText(str(command_val - 2047));
      label_feedback2.setTextBold();
      break;
    case 'E':
      pwm1 = command_val;
      break;
    case 'F':
      pwm2 = command_val;
      break;
    case 'G':
      current1 = command_val;
      label_current1.setText(nf(((command_val - 2047) / 50.0), 1, 1));
      label_current1.setTextBold();
      break;
    case 'H':
      current2 = command_val;
      label_current2.setText(nf(((command_val - 2047) / 50.0), 1, 1));
      label_current2.setTextBold();
      break;
    case 'I':
      temp1 = command_val;
      label_temp1.setText(str(command_val / 30));
      label_temp1.setTextBold();
      break;
    case 'J':
      temp2 = command_val;
      label_temp2.setText(str(command_val / 30));
      label_temp2.setTextBold();
      break;
    case 'M':
      offsetM1_val = 500 - command_val;
      slider_offsetM1.setValue(offsetM1_val);
      break;
    case 'N':
      offsetM2_val = 500 - command_val;
      slider_offsetM2.setValue(offsetM2_val);
      break;
    case 'P':
      pwm_max_val = command_val;
      slider_pwmMax.setValue(pwm_max_val);
      break;
    case 'R':
      kp_val = command_val;
      slider_Kp.setValue(sqrt(kp_val / 4095.0));
      break;
    case 'S':
      ki_val = command_val;
      slider_Ki.setValue(sqrt(ki_val / 4095.0));
      break;
    case 'T':
      kd_val = command_val;
      slider_Kd.setValue(sqrt(kd_val / 4095.0));
      break;
    case 'V':
      speed_ramp_val = command_val;
      slider_speedRamp.setValue(speed_ramp_val);
      break;
    case 'c':                            //  connected to Arduino
      label_connection.setText("Connected to Arduino");
      label_connection.setTextBold();
      label_connection.setLocalColorScheme(1);
      option_manual.setVisible(true);
      option_curve.setVisible(true);
      break;
    case 'd':                            //  disconnected from Arduino
      label_connection.setText("Not connected to Arduino");
      label_connection.setTextBold();
      label_connection.setLocalColorScheme(0);
      exit();
  }
}

//**********************************************************

void pollSerial() {                   // Get serial command from Arduino: "[Ascii,byte,byte]"
  while(bluetooth.available() > 0)
  {
    if (bufferEnd == -1)
    {
      rxByte = bluetooth.read();
      if (rxByte != '[') bufferEnd = -1;
      else bufferEnd = 0;
    }
    else
    {
      rxByte = bluetooth.read();
      rxBuffer[bufferEnd] = rxByte;
      bufferEnd++;
      if (bufferEnd > 3)
      {
        if (rxBuffer[3] == ']')
        {
          command_val = (rxBuffer[1] << 8) + rxBuffer[2];
          parseCommand();
        }
        bufferEnd = -1;
      }
    }
  }
}

//***********************************************************

void values_read_request() {         // request value "X" from Arduino
  sendCommand('r', 'A');
  delay(5);
  sendCommand('r', 'B');
  delay(5);
  sendCommand('r', 'C');
  delay(5);
  sendCommand('r', 'D');
  delay(5);
  sendCommand('r', 'E');
  delay(5);
  sendCommand('r', 'F');
  delay(5);
  sendCommand('r', 'G');
  delay(5);
  sendCommand('r', 'H');
  delay(5);
  sendCommand('r', 'I');
  delay(5);
  sendCommand('r', 'J');
  delay(5);
  sendCommand('r', 'M');
  delay(5);
  sendCommand('r', 'N');
  delay(5);
  sendCommand('r', 'P');
  delay(5);
  sendCommand('r', 'R');
  delay(5);
  sendCommand('r', 'S');
  delay(5);
  sendCommand('r', 'T');
  delay(5);
  sendCommand('r', 'V');
}

//************************************************************

void sendCommand(char sendComm, int sendVal) {

 // println("Command send:  " + sendComm + "  " + hex(sendVal));
 
  txBuffer[0] = '[';
  txBuffer[1] = byte(sendComm);
  txBuffer[2] = byte((sendVal & 0xFF00) >> 8);;
  txBuffer[3] = byte(sendVal & 0xFF);
  txBuffer[4] = ']';
  bluetooth.write(txBuffer);
}