
float period = 3.0;            // Wave variables
float amplitude = 25.0;  
int wavX = 710;
int wavY = 530;
float count = 0.0;
boolean timerOn = false;

//*************************************************************

void waves() {
  
  if(option_curve.isSelected()) {
    stroke(255);
    fill(25);
    rect(wavX, wavY, 250, 125);            // Wave window
  
    stroke(100, 100, 255);

    if(option_sine.isSelected()) {
      renderSine(); 
      if(timerOn) {
        count += period;
        if(count > 359.0) { count = 0.0; }
        target1 = int(sin(radians(count)) * 20.0 * amplitude) + 2047;
        target2 = target1;
        sendCommand('X', target1);       // sending value to both channels
      }
    }    

    if(option_square.isSelected()) {
      renderSquare(); 
      if(timerOn) {
        count += period;
        if (count > 179.0) {
          count = 0.0;
          if(target1 < 2048) { target1 = 2047 + int(20.0 * amplitude); }
          else { target1 = 2047 - int(20.0 * amplitude); }
          target2 = target1;
          sendCommand('X', target1);     // sending value to both channels
        }
      }
    }
  }
}

//**************************************************************

void renderSine() {
  float x = 0.0;
  float val;
  float val_old = 62.5;  
  for (int i = 1; i < 249; i++) {
    val = sin(x) * -amplitude + 62.5;
    line(wavX + i, wavY + val_old, wavX + i +1, wavY + val);
    x += (TWO_PI / (7.0 - period) / 30.0);
    val_old = val;
  }
}

//***************************************************************

void renderSquare() {
  float val = -amplitude;
  float val_old = 0.0;  
  float p = 0.0;
  for (int i = 1; i < 250; i ++) {
    if(p > (7.0 - period) * 15.0) {
      p = 0.0;
      val = -val;
    }
    line(wavX + i, wavY + val_old + 62.5, wavX + i, wavY + val + 62.5);
    val_old = val;
    p ++;
  }
}